/**
 * Test case for create.
 * Runs with nodeunit.
 */

var create = require('../lib/create.js'),
    freeport = require('freeport'),
    apemanApp = require('apeman-app'),
    request = require('request');

exports.setUp = function (done) {
    done();
};

exports.tearDown = function (done) {
    done();
};

exports['Create an app.'] = function (test) {
    var app = create({});
    test.ok(app);
    freeport(function (err, port) {
        test.ifError(err);
        apemanApp('testing-app', {
            configuration: {
                $apps: {
                    'testing-app': {
                        '/': [
                            require('apeman-app-format')(),
                            require('apeman-app-json')(),
                            app,
                            function (req, res, next) {
                                res.send({
                                    foo: 'bar'
                                })
                            }
                        ]
                    }
                }
            },
            port: port
        }, function (err, server) {
            var baseUrl = 'http://localhost:' + port + '/';
            test.ifError(err);
            request(baseUrl + '/foo.json', function (err, res, body) {
                test.ifError(err);
                test.equal(res.statusCode, 200);
                var data = JSON.parse(body);
                test.deepEqual(data, {
                    "foo": "bar"
                });
                server.close();
                test.done();
            });
        });
    });
};

